// C Source File
// Created 3/29/2002; 10:26:07 AM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files


#define ADD	0
#define MUL 1


unsigned int num1=0;
unsigned int num2=0;
unsigned int oper=0;
char sign[2];
unsigned int level=1;
static unsigned int man[]={0x07C0,0x07C0,0x07C0,0x0100,0x01F0,0x0100,0x01F0,0x0100,0x0100,0x07C0,0x1820,0x2010,0x4008,0x8004,0xE007,0xE007};
static unsigned int win[]={0x07C0,0x07C0,0x27C8,0x1110,0x0920,0x0540,0x0380,0x0100,0x0100,0x07C0,0x1820,0x2010,0x4008,0x8004,0xE007,0xE007};
signed int you;
unsigned long int highscore=0;

int numplace(int n){
	if (oper==0){
		if (n<10){
			return(12);
		}
		if (n<100){
			return(6);
		}
	}
	return(0);
}

int generatenums(){
	unsigned int sw;
	oper=random(3);
	if (oper==2||oper==3){
		oper=1;
	}
	if (oper==0){
		num1=random(500-(400-level*50));
		num2=random(500-(400-level*50));
	}
	if (oper==1){
		num1=random(30-(15-level*3));
		num2=random(13-(5-level));
	}
	if (oper==0){
		sprintf(sign,"+");
	}
	if (oper==1){
		sprintf(sign,"*");
	}
	printf_xy(55,40,"     ");
	printf_xy(55,60,"     ");
	if (num1<num2){
		sw=num1;
		num1=num2;
		num2=sw;
	}
	printf_xy(55+numplace(num1),40,"%d",num1);
	DrawStr(55,50,sign,A_REPLACE);
	printf_xy(55+numplace(num2),60,"%d",num2);
	return(0);
}

int winner(int z){
	int a;
	Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
  you=132;
  Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
  for (a=0;a<z;a++){
		Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
		Sprite16(you,9,16,win,LCD_MEM,SPRT_XOR);
  	OSFreeTimer (USER_TIMER);
		OSRegisterTimer (USER_TIMER, 5);
		while (!OSTimerExpired (USER_TIMER));
		Sprite16(you,9,16,win,LCD_MEM,SPRT_XOR);
		Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
		OSFreeTimer (USER_TIMER);
		OSRegisterTimer (USER_TIMER, 5);
		while (!OSTimerExpired (USER_TIMER));
  }
  return(0);
}

int loser(){
	int a,b;
	Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
  you=14;
  Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
  a=9;
  for (b=9;b<=100;b++){
  	Sprite16(you,a,16,man,LCD_MEM,SPRT_XOR);
  	you=14;
  	a=b;
  	Sprite16(you,a,16,man,LCD_MEM,SPRT_XOR);
  	OSFreeTimer (USER_TIMER);
		OSRegisterTimer (USER_TIMER, 2);
		while (!OSTimerExpired (USER_TIMER));
  }
  return(0);
}

int flashscreen(int c){
	signed int a,b;
	for (b=0;b<=c;b++){
		for (a=0;a<=LCD_HEIGHT;a++){
			DrawLine(0,a,LCD_WIDTH,a,A_XOR);
		}
		OSFreeTimer (USER_TIMER);
		OSRegisterTimer (USER_TIMER, 1);
		while (!OSTimerExpired (USER_TIMER));
	}
	return(0);
}







// Main Function
void _main(void)
{
	void *kbq = kbd_queue ();
	unsigned short key;
	unsigned long int score=0;
	unsigned long int num3=0;
	unsigned int wait=0;
	unsigned int key2;
	unsigned long int time=0;
	unsigned long int zzz,yyy;
	char scorec[7];
	level=1;
	randomize();
	ClrScr();
	FontSetSys(F_8x10);
	DrawStr(40,30,"Math Game!",A_NORMAL);
	Sprite16(65,50,16,win,LCD_MEM,SPRT_XOR);
	DrawStr(30,70,"Phil Software",A_NORMAL);
	ngetchx();
	flashscreen(9);
	ClrScr();
	DrawLine(30,25,130,25,A_THICK1);
	Sprite16(80,9,16,man,LCD_MEM,SPRT_XOR);
	FontSetSys(F_6x8);
	you=80;
	generatenums();
	while (1==1){
		OSFreeTimer (USER_TIMER);
		OSRegisterTimer (USER_TIMER, 1);
		while (!OSTimerExpired (USER_TIMER));
		if (!OSdequeue (&key, kbq)){
    	if ((key>=48&&key<=57)&&num3<=9999){
    		key2=key-48;
    		num3*=10;
    		num3+=key2;
    	}
    	if (key==13){
    		if (oper==0){
    			if (num1+num2==num3){
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    				you+=10;
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    				score+=100;
    			}
    			else{
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    				you-=(level*4);
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    			}
    		}
    		else{
    			if (num1*num2==num3){
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    				you+=10;
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    				score+=100;
    			}
    			else{
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    				you-=(level*4);
    				Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    			}
    		}
				generatenums();
    		num3=0;
    		printf_xy(70,80,"     ");
    	}
    	if (key==257){
    		printf_xy(70,80,"     ");
    		num3/=10;
    	}
    	if (key==KEY_CLEAR||key==KEY_MODE||key==KEY_ESC){
    		break;
    	}
    }
    printf_xy(70,80,"%lu",num3);
    wait++;
    if (wait==(20-level*3)){
    	wait=0;
    	Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    	you--;
    	Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    }
    if (you<=14){
    	loser();
    	if (kbhit()){
    		ngetchx();
    	}
    	DrawStr(0,90,"Score:",A_NORMAL);
    	sprintf(scorec,"%lu",score);
    	DrawStr(42,90,scorec,A_REPLACE);
    	if (highscore<score){
    		highscore=score;
    	}
    	ngetchx();
    	printf_xy(30,30,"Highscore:  %lu",highscore);
    	ngetchx();
    	break;
    }
    if (you>=131){
    	winner(18);
    	yyy=score;
    	if (time<5000){
    		score+=(5000-time)*level;
    	}
    	DrawStr(0,90,"Score:",A_NORMAL);
    	for (zzz=yyy;zzz<=score;zzz+=4){
    		sprintf(scorec,"%lu",zzz);
    		DrawStr(42,90,scorec,A_REPLACE);
     	}
     	sprintf(scorec,"%lu",score);
    	DrawStr(42,90,scorec,A_REPLACE);
    	printf_xy(1,1,"Time:  %lu",time);
    	if (kbhit()){
    		ngetchx();
    	}
    	ngetchx();
    	Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);you=80;level++;time=0;generatenums();wait=0;Sprite16(you,9,16,man,LCD_MEM,SPRT_XOR);
    }
    time++;
	}
}
